/* Author:  Robbert van Renesse, Cornell University.
 */

enum camou_direction { CAMOU_ARG, CAMOU_RESULT };

#define ml2c_unit(d, x)		/* void */
#define ml2c_int(d, x)		Int_val(x)
#define ml2c_bool(d, x)		Int_val(x)
#define ml2c_float(d, x)	Double_val(x)

#define c2ml_int(x)		Val_int(x)
#define c2ml_bool(x)		Val_int(x)
#define c2ml_float(x)		copy_double(x)
#define c2ml_mlc(x)		(x)
#define c2ml_exn(x)		((value) (x))

typedef struct vh {
	struct vh *next, **prev;
	int index;
} *value_handle;

typedef value_handle abstract_t;
typedef void *alpha;
typedef int unit_t;
typedef int bool;
typedef int exn;
typedef char *string;
typedef value mlc;

extern value_handle camou_alloc(value);

extern value c2ml_string(string);
extern value c2ml_callback(value, void *);
extern value c2ml_abstract(abstract_t);
extern value c2ml_alpha(alpha);

extern void *ml2c_upcall(enum camou_direction, value);
extern string ml2c_string(enum camou_direction, value);

#define ml2c_abstract(v)	camou_alloc(v)
#define ml2c_alpha(v)		camou_alloc(v)
